/* *****************************************************************************
 * libp7/internals/byteswap.h -- platform-agnostic byteswap utilities.
 * Copyright (C) 2016-2017 Thomas "Cakeisalie5" Touhey <thomas@touhey.fr>
 *
 * This file is part of libp7.
 * libp7 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3.0 of the License,
 * or (at your option) any later version.
 *
 * libp7 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libp7; if not, see <http://www.gnu.org/licenses/>.
 *
 * This file is there to use the platform's byteswapping helpers.
 * If the platform is unrecognized, the lib will try to use the `byteswap.h`
 * header -- if you don't want to modify the library, you should implement it.
 * ************************************************************************** */
#ifndef LIBP7_INTERNALS_BYTESWAP_H
# define LIBP7_INTERNALS_BYTESWAP_H
# if (defined(_WIN16) || defined(_WIN32) || defined(_WIN64)) \
	&& !defined(__WINDOWS__)
#  define __WINDOWS__
# endif

# include <libp7/config.h>
# include <stdint.h>

# if defined(__WINDOWS__)
#  include <stdlib.h>
#  define __p7_bswap_16(B) (_byteswap_ushort(B))
#  define __p7_bswap_32(B) (_byteswap_ulong(B))
#  define __p7_bswap_64(B) (_byteswap_uint64(B))

# else
#  include <byteswap.h>
# endif

#endif /* LIBP7_INTERNALS_BYTESWAP_H */
