/* *****************************************************************************
 * libp7/internals/stdio_ext.h -- platform-agnostic advanced FILE helpers.
 * Copyright (C) 2016-2017 Thomas "Cakeisalie5" Touhey <thomas@touhey.fr>
 *
 * This file is part of libp7.
 * libp7 is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3.0 of the License,
 * or (at your option) any later version.
 *
 * libp7 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libp7; if not, see <http://www.gnu.org/licenses/>.
 *
 * This file is there to use the platform's advanced FILE utilities.
 * Actually, this feature is quite rare, so I accept that the platform doesn't
 * have any.
 * ************************************************************************** */
#ifndef LIBP7_INTERNALS_STDIO_EXT_H
# define LIBP7_INTERNALS_STDIO_EXT_H

/* MS-Windows stuff */
# if (defined(_WIN16) || defined(_WIN32) || defined(_WIN64)) \
	&& !defined(__WINDOWS__)
#  define __WINDOWS__
# endif

/*	Ever heard of how annoying it is to make something platform-agnostic? */
# ifdef __linux__
#  include <stdio_ext.h>
# else
#  define __freadable(F) (1)
#  define __fwritable(F) (1)
# endif

#endif /* LIBP7_INTERNALS_STDIO_EXT_H */
